
* Next macro runs a SCRIPT synchronously (This requires v13, wait.bat and SPSSwait.exe ).

*/////////////////////.
DEFINE !script (!POS=!CMDEND)
/* make sure ok.txt and _syntax.sps do not exist */
HOST COMMAND=['ECHO ok > c:\ok.txt'  'DEL c:\ok.txt' 
	'ECHO *nothing > c:\temp\_syntax.sps'  'DEL c:\temp\_syntax.sps' ] .
SCRIPT !1 .
* Wait until script has finished .
HOST COMMAND=['c:\wait.bat > NUL'].
INSERT FILE='c:\temp\_syntax.sps'.
!ENDDEFINE.
*/////////////////////.

* Notes: the following bat file must exist in c:\ .
*REM This is listing of wait.bat (It needs to be saved in c:\)
 :LOOP
 SPSSwait
 IF NOT EXIST c:\ok.txt GOTO LOOP
 IF EXIST c:\temp\_syntax.sps EXIT
 ECHO * Nothing to do. > c:\temp\_syntax.sps .



* Modify the following macro (if necessary) to contain the path where the SaxBasic scripts are located . 
DEFINE !pathscripts()"C:\Program Files\SPSS\Scripts\"!ENDDEFINE.


*******************.
* EXAMPLE 1 .
*******************.

GET FILE='c:\program files\spss\employee data.sav'.

* define macros containing type of some variables (note that newvar does not exist).
!script !pathscripts + 'define_macro_variables.sbs' ("type / id,gender,salary,newvar").

/* Use macro !salarytype which was defined by the above SCRIPT command */
SET MPRINT=no.
DEFINE !test()
!IF (!EVAL(!salarytype)=string) !THEN
- COMPUTE salary2=NUMBER(salary,F8).
!ELSE !IF (!EVAL(!salarytype)=numeric) !THEN
-             COMPUTE salary2=salary.
	!ELSE
-             COMPUTE salary2=$SYSMIS.
	!IFEND
!IFEND
!ENDDEFINE.

SET MPRINT=yes.
!test.
LIST salary salary2 /CASES = FROM 1 TO 5.
* The new variable salary2 has been corretly defined in the data file.

*******************.
* EXAMPLE 2 .
*******************.

* Say want to get mean of all variables OTHER THAN those between gender and educ (inclusively).
GET FILE='c:\program files\spss\employee data.sav'.
!script !pathscripts + 'define_macro_variables.sbs' ("other / gender TO educ").
AGGREGATE OUTFILE=*
	/BREAK=gender
	/!othervars = MEAN(!othervars).
LIST.

*******************.
* EXAMPLE 3 .
*******************.

* This example gets mean of all variables containing 'sal' in their name.
GET FILE='c:\program files\spss\employee data.sav'.
!script !pathscripts + 'define_macro_variables.sbs' ("list / like *sal* / likesal").
AGGREGATE OUTFILE=*
	/BREAK=gender
	/!likesal = MEAN(!likesal).
LIST.

*******************.
* EXAMPLE 4 . 
*******************.

* Say need to insert variable label in a graph title.
* (The example is not very useful but it shows how we can access the variable label).

GET FILE='c:\program files\spss\employee data.sav'.
!script !pathscripts + 'define_macro_variables.sbs' ("varlab / educ TO salbegin").
DEFINE !test2()
GRAPH  /HISTOGRAM=educ 
  /TITLE=!QUOTE(!CONCAT("Label of educ is ",!EVAL(!educLab))).
!ENDDEFINE.
!test2. 

*******************.
* EXAMPLE 5 .
*******************.

* Say need to write a comma delimited file including all vars of data file.
GET FILE='c:\program files\spss\employee data.sav'.
DEFINE !CommaDelFile(file=!TOKENS(1) /all=!CMDEND)
WRITE OUTFILE=!file TABLE /!HEAD(!all) ','  !DO !v !IN (!TAIL(!all)) !v ',' !DOEND.
!ENDDEFINE.

!script !pathscripts + 'define_macro_variables.sbs' ("list / ALL / allvars").
!CommaDelFile file='c:\temp\test.txt' all=!allvars.

*******************.
* EXAMPLE 6 .
*******************.

* say want to eliminate the "_" in variable names .
* Some data for illustration purposes.
DATA LIST LIST /id var_1 TO var_4 job_cat var22.
BEGIN DATA
1 1 1 1 1 1 1
END DATA.

!script !pathscripts + 'define_macro_variables.sbs' ("remove _ / like *_* / mylist") .
RENAME VARIABLES (!mylist_= !mylist) .
LIST.


*******************.
* EXAMPLE 7 .
*******************.

* say want to use lower case for variable names.
* Some data for illustration purposes.
DATA LIST LIST /ID VAR1 TO VAR4 jobcat VAR22.
BEGIN DATA
1 1 1 1 1 1 1
END DATA.
LIST.

!script !pathscripts + 'define_macro_variables.sbs' ("list lower / ALL / allvars") .
RENAME VARIABLES (!allvars= !allvars) .
* The line above is unusual since the same variables are listed on both sides of the "=" sign.
* on the left hand side, SPSS ignores case and finds the correct variables.
* on the  right hand side, SPSS uses case and hence the case of variable names is changed.
LIST.

*******************.
* EXAMPLE 8 .
*******************.

* Say need to know how many cases and variables there are in data file.
GET FILE='c:\program files\spss\employee data.sav'.
!script !pathscripts + 'define_macro_variables.sbs' ("nb / ALL ") .
TITLE number of variables: !nbvars.
TITLE number of cases: !nbcases.

/* the macro !nbcases can be used to do conditional processing of commands */. 
/* here is an example */

*////////////////////.
DEFINE !doif (!POS=!TOKENS(1))
!IF (!1 !NE 0) !THEN 
LIST /CASES=FROM 1 TO 5.
!ELSE
ECHO 'Nothing to do (there are no cases in data file)'.
!IFEND
!ENDDEFINE.

* Test the macro when there are cases.
!doif !nbvars.

* Test it when there are no case in the data file.
SELECT IF 1=0.
EXECUTE.
!script !pathscripts + 'define_macro_variables.sbs' ("nb / ALL ") .
TITLE !nbcases.
!doif !nbcases.
